import 'package:alien_counter/control/home_screen_control.dart';
import 'package:flutter/material.dart';
import 'package:flutter_gadgets/flutter_gadgets.dart';

import '../const.dart';
import '../model/alien_counter.dart';

class HomeScreen extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: _appBar,
      body: _body,
    );
  }

  AppBar get _appBar => AppBar(
        title: Text('Alien Counter'),
        centerTitle: false,
      );

  Widget get _body => Column(
        crossAxisAlignment: CrossAxisAlignment.center,
        mainAxisAlignment: MainAxisAlignment.center,
        children: [
          SubscriberGadget<AlienCounter>(
            properties: [P_ALIENS],
            builder: (context, counter) {
              print('Building for $P_ALIENS');
              return Text(counter.alienWarning);
            },
          ),
          SizedBox(height: 16),
          SubscriberGadget<AlienCounter>(
            properties: [P_HUMANS],
            builder: (context, counter) {
              print('Building for $P_HUMANS');
              return Text(counter.humanWarning);
            },
          ),
          SizedBox(height: 16),
          SubscriberGadget<AlienCounter>(
            builder: (context, counter) {
              print('Building for $AlienCounter');
              return Text(counter.livingCreature);
            },
          ),
          SizedBox(height: 16),
          Row(
            mainAxisAlignment: MainAxisAlignment.spaceEvenly,
            children: <Widget>[
              FloatingActionButton(
                child: Text('😱'),
                onPressed: onAddAlien,
              ),
              FloatingActionButton(
                child: Text('👽'),
                onPressed: onAddHuman,
              ),
            ],
          ),
        ],
      );
}
