import '../const.dart';
import 'turn.dart';

class Match {
  int cpuWins = 0;
  int playerWins = 0;
  int ties = 0;
  Turn lastTurn;

  void nextTurn(HandSign playerChoice) {
    lastTurn = Turn();
    lastTurn.play(playerChoice);
    _updateWins();
  }

  void _updateWins() {
    if (lastTurnState == TurnState.playerWon) {
      playerWins++;
    } else if (lastTurnState == TurnState.cpuWon) {
      cpuWins++;
    } else {
      ties++;
    }
  }

  MatchState get matchState {
    if (cpuWins == TURNS_TO_WIN) return MatchState.cpuWon;
    if (playerWins == TURNS_TO_WIN) return MatchState.playerWon;
    return MatchState.playing;
  }

  String get matchStateDescription {
    if (cpuWins == TURNS_TO_WIN) return 'Cpu won!';
    if (playerWins == TURNS_TO_WIN) return 'Player won!';
    return 'Playing...';
  }

  TurnState get lastTurnState => lastTurn.state;

  String get lastTurnStateDescription {
    if (lastTurn == null) return 'Your turn.';
    if (lastTurnState == TurnState.playerWon) return 'You won this turn!';
    if (lastTurnState == TurnState.cpuWon) return 'Cpu won this turn!';
    return 'Tie!';
  }
}
